The base class for all Tasks.

Use Project#createTask to register a new Task.

author | Andreas Aderhold
copyright | 2001,2002 THYRELL. All rights reserved
version | $Id$
see | \global\Project#createTask()
package | phing

### Methods

## Returns the textual description of the task

    getDescription() : string

### Returns

`string`The text description of the task

## Returns the location within the buildfile this task occurs.

    getLocation() : \Location

Used by BuildException to give detailed error messages.

### Returns

`\Location`The location object describing the position of this task within the buildfile.

## Returns the owning target of this task.

    getOwningTarget() : \Target

### Returns

`\Target`The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

Inherited

inherited_from | \ProjectComponent::getProject()

### Returns

`\Project`Reference to current porject object

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

### Returns

`\RuntimeConfigurable`The wrapper object used by this task

## Returns the name of task, used only for log messages

    getTaskName() : string

### Returns

`string`Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

### Returns

`string`The type of this task (XML Tag)

## Called by the parser to let the task initialize properly.

    init()

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

### Exceptions

`\BuildException` |

## Provides a project level log event to the task.

    log(string $msg, integer $level)

see | \global\BuildEvent
see | \global\BuildListener

### Parameters

#### $msg

`string`

The message to log

#### $level

`integer`

The priority of the message

## Called by the project to let the task do it's work.

    main()

This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running phing target1 target2 will run all tasks in target3 twice.

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Configure this task if it hasn't been done already.

    maybeConfigure()

## Perfrom this task

    perform()

## Sets a textual description of the task

    setDescription(string $desc)

### Parameters

#### $desc

`string`

The text describing the task

## Sets the location within the buildfile this task occurs.

    setLocation(\Location $location)

Called by the parser to set location information.

### Parameters

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

### Parameters

#### $target

`\Target`

Reference to owning target

## References the project to the current component.

    setProject(\Project $project)

Inherited

inherited_from | \ProjectComponent::setProject()

### Parameters

#### $project

`\Project`

The reference to the current project

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

### Parameters

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Sets the name of this task for log messages

    setTaskName(string $name) : string

### Parameters

#### $name

`string`

### Returns

`string`A string representing the name of this task for log

## Sets the type of the task.

    setTaskType(string $name)

Usually this is the name of the XML tag

### Parameters

#### $name

`string`

The type of this task (XML Tag)

## Returns a name

    getRegisterSlot(string $slotName)

### Parameters

#### $slotName

`string`

### Properties

##

    $description : string

##

    $location : \Location

##

    $project : \Project

Inherited

inherited_from | \ProjectComponent::$$project

##

    $target : \Target

##

    $taskName : string

##

    $taskType : string

##

    $wrapper : \RuntimeConfigurable